mod Ex02a

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end pondelok 16.2.2009 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0809ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a definiciam predikatov. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/0 Tex_f0_foo
  Std('?',0)

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

appldisp/2 Tex_f2_n_max
  Std('max',0)

appldisp/2 Tex_f2_n_exp
  Subsup(Arg(0),75,None,Arg(1))

appldisp/1 Tex_f1_n_fib
  Subsup(Id(0,'fib',0),75,Arg(0),None)

appldisp/2 Tex_f2_n_div
  Infix(Arg(0),45,1,Op(Ent('div'),0),Arg(1))

appldisp/2 Tex_p2_n_divides
  Infix(Arg(0),25,0,Op(Ent('mid'),0),Arg(1))

appldisp/2 Tex_f2_n_gcd
  Std('gcd',0)

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Explicit Definitions.  \end 

rem 
  \para \bf  Maximum.  \end 

fun/2 Max 'Tex_f2_n_max'
  Max(x,y) = x <- x >= y
  Max(x,y) = y <- x < y

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Exponentiation.  \end \header* fun/2 Exp 'Tex_f2_n_exp' \end 
  \eq* 
    Exp(x,0) = 1
  \end
  \eq* 
    Exp(x,y+1) = x*Exp(x,y)
  \end

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,0) = 1
  Exp(x,y) = x*Exp(x,y-1) <- y != 0

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Fibonacci sequence.  \end \header* fun Fib 'Tex_f1_n_fib' \end 
  \eq* 
    Fib(0) = 0
  \end
  \eq* 
    Fib(1) = 1
  \end
  \eq* 
    Fib(n+2) = Fib(n+1)+Fib(n)
  \end

fun Fib 'Tex_f1_n_fib'
  Fib(n) = Foo

rem 
  \para \bf  Integer division.  \end Specification: 
  \eq* 
    x/0 = 0
  \end
  \eq* 
    y != 0 -> \e r(x = x/y*y+r & r < y)
  \end
  \para Find a course of values recursive definition of the integer division 
  function. 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Substitution in 
  Parameters.  \end 

rem 
  \para \bf  Divisibility predicate.  \end 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> \e z y = x*z

rem 
  \para \bf  Greatest common divisor.  \end Specification: 
  \eq* 
    x != 0 \/ y != 0 -> 
    Divides(Tex_f2_n_gcd(x,y),x) & Divides(Tex_f2_n_gcd(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Tex_f2_n_gcd(x,y)
  \end
  \para Find a course of values recursive definition of the greatest common 
  divisor function based on the property 
  \eq* 
    x != 0 & Divides(z,x) -> Divides(z,y) <-> Divides(z,y mod x)
  \end

fun/2 Gcd1 'Tex_f2_n_gcd'
  Gcd1(x,y) = Foo

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Greatest common divisor.  \end Specification: 
  \eq* 
    x != 0 \/ y != 0 -> 
    Divides(Tex_f2_n_gcd(x,y),x) & Divides(Tex_f2_n_gcd(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Tex_f2_n_gcd(x,y)
  \end
  \para Find a course of values recursive definition of the greatest common 
  divisor function based on the property 
  \eq* 
    x < y & Divides(z,x) -> Divides(z,y) <-> Divides(z,y-x)
  \end

fun/2 Gcd2 'Tex_f2_n_gcd'
  Gcd2(x,y) = Foo <- x = 0
  Gcd2(x,y) = Foo <- x != 0 & y = 0
  Gcd2(x,y) = Foo <- x != 0 & y != 0

